﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Steema.TeeChart;
using Steema.TeeChart.Drawing;
using System.Drawing;
using System.Xml;
using System.Data;
namespace SupportApp
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        Steema.TeeChart.Web.WebChart WebChart1;
        protected void Page_Load(object sender, EventArgs e)
        {
            InitializeChart("","");
        }

        private void InitializeChart(string BatchID, string Activity)
        {
            
            string strTrenddata = string.Empty;
            string strerrormsg = string.Empty;
            
            string rootFolderPath = string.Empty;
            string filesToDelete = string.Empty;

            try
            {
                

                    // Loop for distinct Groups - as each group generates different Trend graph 
                    
                    {
                        


                            // Get the no_of_y_axis, chart_title, x_axis_type, time_scale of the group considering all tags in the group have same values for X-axis
                            int no_of_y_axis = 3;
                            string chart_title = "";
                            string x_axis_type = "";
                            double time_scale = 0;
                            string x_axis_label = "";

                           
                           
                            {  // Dynamic X-axis

                                WebChart1 = new Steema.TeeChart.Web.WebChart();
                                
                                // Set chart basic properties
                                //WebChart1.Chart.Graphics3D.BackColor = Color.White;
                                WebChart1.Chart.Aspect.View3D = false;
                                WebChart1.Chart.Header.Visible = true;
                                WebChart1.Chart.Header.Text = chart_title;
                                WebChart1.Chart.Legend.Alignment = LegendAlignments.Bottom;
                                WebChart1.Chart.Legend.Visible = true;
                                Steema.TeeChart.Axis bottomAxis = WebChart1.Chart.Axes.Bottom;
                                bottomAxis.Grid.Visible = false;

                                WebChart1.Chart.Panel.Gradient.Visible = false;
                                WebChart1.Chart.Panel.Color = Color.White;
                                //Do doesn't visible Wall Back
                                WebChart1.Chart.Walls.Back.Visible = false;
                                WebChart1.Chart.Walls.Back.Color = Color.White;
                                
                                int width = 0;
                                for (int i = 0; i < no_of_y_axis; i++)
                                {
                                    //string TagName = dt1.Rows[i]["tag"].ToString();
                                    string TagName = "";
                                    string tag = string.Empty;
                                    if (i == 0)
                                        TagName = "1120BXA001/OUT.CV";
                                    else if (i == 1)
                                        TagName = "1120BPIT001/OUT.CV";
                                    else
                                        TagName = "1120BWT001/OUT.CV";

                                    tag = ConvertToUnicode(TagName);

                                    string y_axis_type = "dynamic";

                                    new Steema.TeeChart.Styles.Line(WebChart1.Chart);

                                    double maxvalue = 0;

                                    XmlDocument doc = new XmlDocument();
                                    doc.Load(@"D:\webparts\PV\SupportApp\SupportApp\Input.xml");
                                    strTrenddata = doc.InnerXml;
                                    WebChart1.Chart[i].DataSource = GetData(tag, strTrenddata, out maxvalue);//Add values using DataSource

                                    // X-axis setting
                                    WebChart1.Chart[i].XValues.DataMember = "DateTime";
                                    WebChart1.Chart[i].XValues.DateTime = true;

                                    WebChart1.Chart.Axes.Custom.Add(new Steema.TeeChart.Axis(WebChart1.Chart));

                                    WebChart1.Chart[i].CustomVertAxis = WebChart1.Chart.Axes.Custom[i];
                                    
                                    bottomAxis.Labels.DateTimeFormat = "yyyy-dd-MM\nHH:mm";
                                   
                                    bottomAxis.Labels.Angle = 90;
                                   

                                    //WebChart1.Chart[i].Color = GetSeriesColor(data.Field<int>("colour_of_series"));
                                    WebChart1.Chart.Axes.Custom[i].AxisPen.Width = 1;
                                    WebChart1.Chart.Axes.Custom[i].AxisPen.Color = WebChart1.Chart[i].Color;
                                    WebChart1.Chart.Axes.Custom[i].Grid.Visible = false;
                                    WebChart1.Chart.Axes.Custom[i].Title.Visible = false;

                                    if (y_axis_type == "fixed") //When fixed, then unit size of y-axis is determined by y_min_value and y_max_value
                                    {
                                        WebChart1.Chart[i].CustomVertAxis.Automatic = false;
                                        WebChart1.Chart[i].CustomVertAxis.Maximum = 1;
                                        WebChart1.Chart[i].CustomVertAxis.Minimum = 100;
                                        WebChart1.Chart[i].CustomVertAxis.Increment = 1;
                                    }
                                    else //When dynamic, the y-axis units are calculated from min and max of the sampled values
                                    {
                                        WebChart1.Chart[i].CustomVertAxis.Automatic = true;
                                        WebChart1.Chart[i].CustomVertAxis.SetMinMax(0, maxvalue);
                                        //WebChart1.Chart[i].CustomVertAxis.Increment = 1;
                                    }


                                    WebChart1.Chart.Axes.Custom[i].Title.Caption = "";
                                    WebChart1.Chart.Axes.Custom[i].Title.Angle = 90;
                                    WebChart1.Chart[i].YValues.DataMember = "SystemName";
                                    // WebChart1.Chart[i].CustomVertAxis.StartPosition = 0;
                                    WebChart1.Chart[i].CustomVertAxis.Labels.ValueFormat = "####;{####}";


                                    //WebChart1.Chart[i].CustomVertAxis.Labels.Separation = 10;
                                    WebChart1.Chart.Axes.Custom[i].PositionUnits = PositionUnits.Pixels;
                                    WebChart1.Chart.Width = 1100;
                                    WebChart1.Chart.Height = 600;


                                    WebChart1.Chart.Legend.Items.Add(new LegendItem(WebChart1.Chart.Legend) { Text = "" });
                                    WebChart1.Chart.Legend.Title.Visible = false;
                                    WebChart1.Chart.Legend.Title.Text = x_axis_label;
                                    WebChart1.Chart.Legend.Font.Size = 6;
                                    WebChart1.Chart.Panel.MarginUnits = Steema.TeeChart.PanelMarginUnits.Pixels;

                                }

                                PlaceAxes(0, 0, 0, 0, 0);
                                WebChart1.AfterDraw += new Steema.TeeChart.PaintChartEventHandler(WebChart1_AfterDraw);
                                WebChart1.Chart.Export.Image.PNG.Save(@"D:\Trend.png");
                                
                            }

                        }
                    }
                
            
            catch (Exception ex)
            {
                
            }
        }
        private string ConvertToUnicode(string data)
        {

            try
            {
                string str = data.Substring(0, 1);
                int result;

                if (Int32.TryParse(str, out result))
                {
                    data = "_x003" + str + "_" + data.Substring(1, data.Length - 1);
                }

                data = data.Replace("?", "_x003F_");
                data = data.Replace(" ", "_x0020_");
                data = data.Replace("/", "_x002F_");
                data = data.Replace("=", "_x003D_");
                data = data.Replace("%", "_x0025_");
                string slash = "\\";
                data = data.Replace(slash, "_x005C_");
                data = data.Replace("~", "_x007E_");
                data = data.Replace("@", "_x0040_");
                data = data.Replace("#", "_x0023_");
                data = data.Replace("$", "_x0024_");
                data = data.Replace("%", "_x0025_");
                data = data.Replace("^", "_x005E_");
                data = data.Replace("&", "_x0026_");
                data = data.Replace("*", "_x002A_");
                data = data.Replace("(", "_x0028_");
                data = data.Replace(")", "_x0029_");
                data = data.Replace("+", "_x002B_");
                data = data.Replace("{", "_x007B_");
                data = data.Replace("}", "_x007D_");
                data = data.Replace("|", "_x007C_");
                data = data.Replace("'", "_x0027_");
                data = data.Replace("<", "_x003C_");
                data = data.Replace(">", "_x003E_");
                data = data.Replace(",", "_x002C_");
                data = data.Replace(";", "_x003B_");
                data = data.Replace(":", "_x003A_");
            }
            catch (Exception ex)
            {
               
            }
            return data;

        }

        private DataSet GetData(string TagName, string strTrenddata, out double maxvalue)
        {

            XmlDocument doc = new XmlDocument();
            DataSet TeeDataSet = new DataSet();
            DateTime dt = DateTime.Today;
            Int32 maxVal = 0;
            try
            {
                doc.LoadXml(strTrenddata);

                maxvalue = 0;

                DataTable TeeDataTable = new DataTable("DataTable1");
                DataColumn xval = new DataColumn("DateTime", typeof(DateTime));
                DataColumn yval = new DataColumn("SystemName", typeof(double));

                TeeDataTable.Columns.Add(xval);
                TeeDataTable.Columns.Add(yval);

                TagName = TagName.Split('/')[0];

                XmlDocument pardoc = new XmlDocument();
                foreach (XmlNode xnList in doc.SelectNodes("/*[local-name()='TrendData']/*[local-name()='TrendDataSet']"))
                {
                    foreach (XmlNode xnList1 in xnList.ChildNodes)
                    {
                        string str = xnList1.Name;

                        XmlNode parentnode = xnList1.ParentNode;
                        pardoc.LoadXml(parentnode.OuterXml);

                        if (str == TagName)
                        {
                            //add
                            DataRow newRow = TeeDataTable.NewRow();
                            newRow[xval] = pardoc.SelectSingleNode("/*[local-name()='TrendDataSet']/*[local-name()='TimeStamp']").InnerText;
                            newRow[yval] = xnList1.InnerText;
                            TeeDataTable.Rows.Add(newRow);
                        }
                    }

                }
                TeeDataSet.Tables.Add(TeeDataTable);
                var maxVal1 = TeeDataTable.AsEnumerable()
                        .Max(r => r.Field<double>("SystemName"));
                maxVal = Convert.ToInt32(maxVal1);

            }
            catch (Exception ex)
            {
                
            }
            maxvalue = maxVal;
            return TeeDataSet;

        }
        protected void WebChart1_AfterDraw(object sender, Steema.TeeChart.Drawing.Graphics3D g)
        {
            PlaceAxes(0, 0, 0, 0, 0);

            
        }

        private void PlaceAxes(int nSeries, int NextXLeft, int NextXRight, int MargLeft, int MargRight)
        {
           

            const int extraPos = 12;
            const int extraMargin = 50;
            Steema.TeeChart.Chart ch1 = WebChart1.Chart;
            //Variable 
            int MaxLabelsWidth;
            int lenghtTicks;
            int extraSpaceBetweenTitleAndLabels;
            foreach (Steema.TeeChart.Styles.Line s in ch1.Series)
            {
                if (s.CustomVertAxis != null)
                {
                    MaxLabelsWidth = s.CustomVertAxis.MaxLabelsWidth();
                    lenghtTicks = s.CustomVertAxis.Ticks.Length;
                    extraSpaceBetweenTitleAndLabels = (s.CustomVertAxis.Title.Width);//- tChart1.Axes.Custom[nSeries].MaxLabelsWidth());
                    if (s.CustomVertAxis.Title.Visible)
                    {
                        s.CustomVertAxis.RelativePosition = NextXLeft;
                        NextXLeft = NextXLeft - (MaxLabelsWidth + lenghtTicks + extraSpaceBetweenTitleAndLabels + extraPos);
                        MargLeft = MargLeft + extraMargin;
                    }
                    else
                    {
                        s.CustomVertAxis.RelativePosition = NextXLeft;
                        if (ch1.Series.Count == 3)
                            NextXLeft = NextXLeft - (MaxLabelsWidth + lenghtTicks + extraPos);
                        else
                            NextXLeft = NextXLeft - (MaxLabelsWidth + lenghtTicks + extraPos + 25);
                        MargLeft = MargLeft + extraMargin;
                    }
                }

                ch1.Panel.MarginLeft = MargLeft;
            }
        }
    }
}